#line 1 "C:/Users/Eric/Documents/PIC - Programmes/16F887/Programmes en mise au point (16F887)/Two_servomotors_with_three_timers_with_joystick.c"
#line 13 "C:/Users/Eric/Documents/PIC - Programmes/16F887/Programmes en mise au point (16F887)/Two_servomotors_with_three_timers_with_joystick.c"
unsigned int cnt0, i, j, k;
unsigned int consigne_1, consigne_0;
unsigned char *p0, *p1;
int joystick_X, joystick_Y;

volatile unsigned char flag_TMR1;



void ADC_initialization()
{
 ADCON0 = 0b01000001;









 ADCON1 = 0b10000000;









}

unsigned int ADC_read(unsigned char channel)


{
 unsigned int k;
 ADCON0 = ADCON0 & 0b11000011;







 channel = channel << 2;
 ADCON0 = ADCON0 | channel;

 Delay_ms(2);
 ADCON0.GO_DONE = 1;

 _asm NOP;
 while (ADCON0.GO_DONE == 1);
 {
 k = ADRESL + (ADRESH * 256);

 return(k);
 }
}










void Init_Timer2()
{

 T2CON = 0x26;
 PR2 = 250;

 TMR2IE_bit = 1;
 INTCON = 0xC0;
}






void Init_Timer1()
{

 T1CON = 0x01;

 TMR1IF_bit = 0;
 TMR1H = 0xFC;
 TMR1L = 0x18;
 TMR1IE_bit = 1;
 INTCON = 0xC0;

 flag_TMR1 = 1;
}






void Init_Timer0()
{

 OPTION_REG = 0x88;


 TMR0 = 156;
 INTCON = 0xA0;


 cnt0 = 0;
}



void Interrupt()
{
 if (TMR2IF_bit && TMR2IE_bit)

 {

 TMR0IF_bit = 0;
 p0 = &consigne_0;
 TMR0 = *(p0);

 portd.b0 = 1;
 portc.b2 = 1;


 TMR1IF_bit = 0;
 p1 = &consigne_1;
 TMR1L = *(p1);
 TMR1H = *(p1+1);



 flag_TMR1 = 1;
 portd.b1 = 1;
 portc.b2 = 1;


 TMR2IF_bit = 0;
 PR2 = 250;

 }

 if (TMR0IF_bit && TMR0IE_bit)

 {
 TMR0IF_bit = 0;
 TMR0 = *(p0);

 cnt0++;
 }

 if (TMR1IF_bit && TMR1IE_bit)

 {
 TMR1IF_bit = 0;
 TMR1L = *(p1);
 TMR1H = *(p1+1);


 flag_TMR1 = 0;
 portd.b1 = 0;
 portc.b2 = 0;
 }
}



void ton_servo_lower (unsigned int consigne_0)
{



 i = 0;

 do
 {
 Init_Timer2();
 Init_Timer0();
 while(cnt0 < consigne_0)
 {
 portd.b0 = 1;
 portc.b2 = 1;
 }
 portd.b0 = 0;
 portc.b2 = 0;
 i++;
 }



 while(i < 5);





}

void ton_servo_lower_with_turning_time (unsigned int consigne_0, unsigned int turning_time)
{



 i = 0;

 do
 {
 Init_Timer2();
 Init_Timer0();
 while(cnt0 < consigne_0)
 {
 portd.b0 = 1;
 portc.b2 = 1;
 }
 portd.b0 = 0;
 portc.b2 = 0;
 i++;
 }
 while(i < turning_time);


}

void ton_servo_upper (unsigned int consigne_1)
{



 i = 0;

 do
 {
 Init_Timer2();
 Init_Timer1();
 while(flag_TMR1 == 1)
 {
 portd.b1 = 1;
 portc.b2 = 1;
 }
 portd.b1 = 0;
 portc.b2 = 0;
 i++;
 }




 while(i < 50);

}



void main()
{
 TRISC = 0;
 PORTC = 0;
 TRISD = 0;
 PORTD = 0;

 ADC_initialization();
#line 1383 "C:/Users/Eric/Documents/PIC - Programmes/16F887/Programmes en mise au point (16F887)/Two_servomotors_with_three_timers_with_joystick.c"
 while(1)
 {


 Init_Timer2();
 Init_Timer0();

 p0 = &TMR0;

 joystick_X = (ADC_read(0));

 if ((joystick_X <= 500) && (joystick_X > 5))
 {

 consigne_0 = 100 + (joystick_X / 10);

 sprintl(*p0, "%3u", consigne_0);

 Init_Timer2();
 Init_Timer0();

 while(cnt0 < (consigne_0 / 10))
 {
 portd.b1 = 0;
 portd.b0 = 1;
 portc.b2 = 1;
 }

 portd.b0 = 0;
 portc.b2 = 0;
 }

 if ((joystick_X >= 512) && (joystick_X < 1012))
 {

 consigne_0 = 150 + (joystick_X - 512) / 10;

 sprintl(*p0, "%3u", consigne_0);

 Init_Timer2();
 Init_Timer0();

 while(cnt0 < (consigne_0 / 10))
 {
 portd.b1 = 0;
 portd.b0 = 1;
 portc.b2 = 1;
 }

 portd.b0 = 0;
 portc.b2 = 0;
 }

 if ((joystick_X > 500) && (joystick_X < 512))
 {
 portd.b1 = 0;
 portd.b0 = 0;
 portc.b2 = 0;
 }



 Init_Timer2();
 Init_Timer1();

 p1 = &TMR1L;

 joystick_Y = (ADC_read(1));


 if ((joystick_Y <= 490) && (joystick_Y > 250))
 {
 portd.b0 = 0;
 consigne_1 = 65535 - 1500;

 sprintl(*p1, "%5u", consigne_1);
 Delay_ms(1000);
 }

 if ((joystick_Y <= 250) && (joystick_Y > 0))
 {
 portd.b0 = 0;
 consigne_1 = 65535 - 1750;

 sprintl(*p1, "%5u", consigne_1);
 Delay_ms(1000);
 }


 if ((joystick_Y >= 534) && (joystick_Y < 774))
 {
 portd.b0 = 0;
 consigne_1 = 65535 - 1400;

 sprintl(*p1, "%5u", consigne_1);
 Delay_ms(1000);
 }

 if ((joystick_Y >= 774) && (joystick_Y < 1024))
 {
 portd.b0 = 0;
 consigne_1 = 65535 - 1250;

 sprintl(*p1, "%5u", consigne_1);
 Delay_ms(1000);
 }


 if ((joystick_Y > 490) && (joystick_Y < 534))

 {
 portd.b0 = 0;
 portd.b1 = 0;
 portc.b2 = 0;
 }
 }

}
