
_ADC_initialization:

;Two_servomotors_with_three_timers_with_joystick.c,22 :: 		void ADC_initialization()
;Two_servomotors_with_three_timers_with_joystick.c,24 :: 		ADCON0 = 0b01000001;              // b0 = 1 (ADON) : le convertisseur A/N interne est activ.
	MOVLW      65
	MOVWF      ADCON0+0
;Two_servomotors_with_three_timers_with_joystick.c,34 :: 		ADCON1 = 0b10000000;              // b0 = b1 = b2 = b3 = 0 : Unimplemented. Read as '0'.
	MOVLW      128
	MOVWF      ADCON1+0
;Two_servomotors_with_three_timers_with_joystick.c,44 :: 		}
L_end_ADC_initialization:
	RETURN
; end of _ADC_initialization

_ADC_read:

;Two_servomotors_with_three_timers_with_joystick.c,46 :: 		unsigned int ADC_read(unsigned char channel)
;Two_servomotors_with_three_timers_with_joystick.c,51 :: 		ADCON0 = ADCON0 & 0b11000011;     // ADCON0 = 01000001
	MOVLW      195
	ANDWF      ADCON0+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,59 :: 		channel = channel << 2;           // Dcalage channel de 2 bits  gauche pour placer la valeur de channel dans bits b2 b3 b4 b5 (CHS0 CHS1 CHS2 CHS3).
	MOVF       FARG_ADC_read_channel+0, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	MOVWF      FARG_ADC_read_channel+0
;Two_servomotors_with_three_timers_with_joystick.c,60 :: 		ADCON0 = ADCON0 | channel;        // OU logique bit  bit entre ADCON0 et channel.
	MOVF       R0+0, 0
	IORWF      ADCON0+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,62 :: 		Delay_ms(2);                      // Dlais de 2 mS minimum. >>> A ajuster si besoin. <<<
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_ADC_read0:
	DECFSZ     R13+0, 1
	GOTO       L_ADC_read0
	DECFSZ     R12+0, 1
	GOTO       L_ADC_read0
	NOP
	NOP
;Two_servomotors_with_three_timers_with_joystick.c,63 :: 		ADCON0.GO_DONE = 1;               // Dclenchement de la conversion A/N.
	BSF        ADCON0+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,65 :: 		_asm NOP;                         // Recommand par Microchip.
	NOP
;Two_servomotors_with_three_timers_with_joystick.c,66 :: 		while (ADCON0.GO_DONE == 1);      // Attendre que le bit GO.DONE passe  0.
L_ADC_read1:
	BTFSS      ADCON0+0, 1
	GOTO       L_ADC_read2
	GOTO       L_ADC_read1
L_ADC_read2:
;Two_servomotors_with_three_timers_with_joystick.c,68 :: 		k = ADRESL + (ADRESH * 256);     // XXX A REVOIR XXX
	MOVF       ADRESH+0, 0
	MOVWF      R0+1
	CLRF       R0+0
	MOVF       ADRESL+0, 0
	ADDWF      R0+0, 1
	BTFSC      STATUS+0, 0
	INCF       R0+1, 1
;Two_servomotors_with_three_timers_with_joystick.c,70 :: 		return(k);
;Two_servomotors_with_three_timers_with_joystick.c,72 :: 		}
L_end_ADC_read:
	RETURN
; end of _ADC_read

_Init_Timer2:

;Two_servomotors_with_three_timers_with_joystick.c,83 :: 		void Init_Timer2()
;Two_servomotors_with_three_timers_with_joystick.c,86 :: 		T2CON = 0x26;
	MOVLW      38
	MOVWF      T2CON+0
;Two_servomotors_with_three_timers_with_joystick.c,87 :: 		PR2 = 250;             // Timer2 8 bits register is preloaded with 250 in order to count from 250 to 256, 5 cycles of 20 mS = 100 mS,
	MOVLW      250
	MOVWF      PR2+0
;Two_servomotors_with_three_timers_with_joystick.c,89 :: 		TMR2IE_bit = 1;        // Sets Interrupt Enable bit to 1.
	BSF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
;Two_servomotors_with_three_timers_with_joystick.c,90 :: 		INTCON = 0xC0;         // GIE = 1.
	MOVLW      192
	MOVWF      INTCON+0
;Two_servomotors_with_three_timers_with_joystick.c,91 :: 		}
L_end_Init_Timer2:
	RETURN
; end of _Init_Timer2

_Init_Timer1:

;Two_servomotors_with_three_timers_with_joystick.c,98 :: 		void Init_Timer1()
;Two_servomotors_with_three_timers_with_joystick.c,101 :: 		T1CON = 0x01;          // T1CON register > b0 > TMR1ON bit = 1 > Timer1 is enabled.
	MOVLW      1
	MOVWF      T1CON+0
;Two_servomotors_with_three_timers_with_joystick.c,103 :: 		TMR1IF_bit = 0;        // Sets Interrupt Flag bit to 0.
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;Two_servomotors_with_three_timers_with_joystick.c,104 :: 		TMR1H = 0xFC;          // Timer1 16 bits register is preloaded with 64536 in order to count from 64536 to 65536, 1000 cycles of 1 uS = 1 mS.
	MOVLW      252
	MOVWF      TMR1H+0
;Two_servomotors_with_three_timers_with_joystick.c,105 :: 		TMR1L = 0x18;          //
	MOVLW      24
	MOVWF      TMR1L+0
;Two_servomotors_with_three_timers_with_joystick.c,106 :: 		TMR1IE_bit = 1;        // Sets Interrupt Enable bit to 1.
	BSF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
;Two_servomotors_with_three_timers_with_joystick.c,107 :: 		INTCON = 0xC0;         // INTCON register > b6 > PEIE bit = 1 > All unmasked peripheral interrupts are enabled.
	MOVLW      192
	MOVWF      INTCON+0
;Two_servomotors_with_three_timers_with_joystick.c,109 :: 		flag_TMR1 = 1;         // Timer1 is counting.
	MOVLW      1
	MOVWF      _flag_TMR1+0
;Two_servomotors_with_three_timers_with_joystick.c,110 :: 		}
L_end_Init_Timer1:
	RETURN
; end of _Init_Timer1

_Init_Timer0:

;Two_servomotors_with_three_timers_with_joystick.c,117 :: 		void Init_Timer0()
;Two_servomotors_with_three_timers_with_joystick.c,120 :: 		OPTION_REG = 0x88;     // OPTION_REG register > b0 > PS0 bit = 0 > Prescaler rate : 1:1.
	MOVLW      136
	MOVWF      OPTION_REG+0
;Two_servomotors_with_three_timers_with_joystick.c,123 :: 		TMR0 = 156;            // Timer0 8 bits register is preloaded with 156 in order to count from 156 to 256, 100 cycles of 1 uS = 100 uS = 0,1 mS.
	MOVLW      156
	MOVWF      TMR0+0
;Two_servomotors_with_three_timers_with_joystick.c,124 :: 		INTCON = 0xA0;         // INTCON register > b2 > TOIF bit = 0 > Resets the bit in order to allow TMR0 to count pulses from internal oscillator.
	MOVLW      160
	MOVWF      INTCON+0
;Two_servomotors_with_three_timers_with_joystick.c,127 :: 		cnt0 = 0;              // Resets "100 uS" counter.
	CLRF       _cnt0+0
	CLRF       _cnt0+1
;Two_servomotors_with_three_timers_with_joystick.c,128 :: 		}
L_end_Init_Timer0:
	RETURN
; end of _Init_Timer0

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;Two_servomotors_with_three_timers_with_joystick.c,132 :: 		void Interrupt()
;Two_servomotors_with_three_timers_with_joystick.c,134 :: 		if (TMR2IF_bit && TMR2IE_bit)      // After 20 mS elapsed with Timer2 ...
	BTFSS      TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	GOTO       L_Interrupt5
	BTFSS      TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
	GOTO       L_Interrupt5
L__Interrupt63:
;Two_servomotors_with_three_timers_with_joystick.c,138 :: 		TMR0IF_bit = 0;                // Resets Interrupt Flag.
	BCF        TMR0IF_bit+0, BitPos(TMR0IF_bit+0)
;Two_servomotors_with_three_timers_with_joystick.c,139 :: 		p0 = &consigne_0;
	MOVLW      _consigne_0+0
	MOVWF      _p0+0
;Two_servomotors_with_three_timers_with_joystick.c,140 :: 		TMR0 = *(p0);
	MOVF       _p0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      TMR0+0
;Two_servomotors_with_three_timers_with_joystick.c,142 :: 		portd.b0 = 1;                  // Servomotor LOWER ON.
	BSF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,143 :: 		portc.b2 = 1;                  // LED ON.
	BSF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,146 :: 		TMR1IF_bit = 0;                // Resets Interrupt Flag.
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;Two_servomotors_with_three_timers_with_joystick.c,147 :: 		p1 = &consigne_1;              // Initilization of pointeur p1 with memory address contained in consigne_1. p1 = l'adresse de consigne_1.
	MOVLW      _consigne_1+0
	MOVWF      _p1+0
;Two_servomotors_with_three_timers_with_joystick.c,148 :: 		TMR1L = *(p1);                 // Reloads TMR1L with value contained at memory address contained in consigne_1, pointed by p1. TMR1L = contenu de l'adresse de p1.
	MOVF       _p1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      TMR1L+0
;Two_servomotors_with_three_timers_with_joystick.c,149 :: 		TMR1H = *(p1+1);               // Reloads TMR1H with value contained at memory address contained in consigne_1, pointed by p1, incremented by + 1.
	INCF       _p1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      TMR1H+0
;Two_servomotors_with_three_timers_with_joystick.c,153 :: 		flag_TMR1 = 1;                 // Timer1 is counting.
	MOVLW      1
	MOVWF      _flag_TMR1+0
;Two_servomotors_with_three_timers_with_joystick.c,154 :: 		portd.b1 = 1;                  // Servomotor UPPER ON.
	BSF        PORTD+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,155 :: 		portc.b2 = 1;                  // LED ON.
	BSF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,158 :: 		TMR2IF_bit = 0;                // Resets Interrupt Flag.
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
;Two_servomotors_with_three_timers_with_joystick.c,159 :: 		PR2 = 250;                     // Reloads Timer2 8 bits register with 250 in order to count from 250 to 256, 5 cycles of 20 mS = 100 mS,
	MOVLW      250
	MOVWF      PR2+0
;Two_servomotors_with_three_timers_with_joystick.c,161 :: 		}
L_Interrupt5:
;Two_servomotors_with_three_timers_with_joystick.c,163 :: 		if (TMR0IF_bit && TMR0IE_bit)      // After 100 uS elapsed with TMR0 ...
	BTFSS      TMR0IF_bit+0, BitPos(TMR0IF_bit+0)
	GOTO       L_Interrupt8
	BTFSS      TMR0IE_bit+0, BitPos(TMR0IE_bit+0)
	GOTO       L_Interrupt8
L__Interrupt62:
;Two_servomotors_with_three_timers_with_joystick.c,166 :: 		TMR0IF_bit = 0;
	BCF        TMR0IF_bit+0, BitPos(TMR0IF_bit+0)
;Two_servomotors_with_three_timers_with_joystick.c,167 :: 		TMR0 = *(p0);
	MOVF       _p0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      TMR0+0
;Two_servomotors_with_three_timers_with_joystick.c,169 :: 		cnt0++;                        // Increments "100 uS" counter.
	INCF       _cnt0+0, 1
	BTFSC      STATUS+0, 2
	INCF       _cnt0+1, 1
;Two_servomotors_with_three_timers_with_joystick.c,170 :: 		}
L_Interrupt8:
;Two_servomotors_with_three_timers_with_joystick.c,172 :: 		if (TMR1IF_bit && TMR1IE_bit)      // After n x 1 mS elapsed with TMR1 ...
	BTFSS      TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	GOTO       L_Interrupt11
	BTFSS      TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
	GOTO       L_Interrupt11
L__Interrupt61:
;Two_servomotors_with_three_timers_with_joystick.c,175 :: 		TMR1IF_bit = 0;
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
;Two_servomotors_with_three_timers_with_joystick.c,176 :: 		TMR1L = *(p1);
	MOVF       _p1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      TMR1L+0
;Two_servomotors_with_three_timers_with_joystick.c,177 :: 		TMR1H = *(p1+1);
	INCF       _p1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      TMR1H+0
;Two_servomotors_with_three_timers_with_joystick.c,180 :: 		flag_TMR1 = 0;                 // Timer1 stops counting.
	CLRF       _flag_TMR1+0
;Two_servomotors_with_three_timers_with_joystick.c,181 :: 		portd.b1 = 0;                  // Servomotor UPPER OFF.
	BCF        PORTD+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,182 :: 		portc.b2 = 0;                  // LED OFF.
	BCF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,183 :: 		}
L_Interrupt11:
;Two_servomotors_with_three_timers_with_joystick.c,184 :: 		}
L_end_Interrupt:
L__Interrupt78:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_ton_servo_lower:

;Two_servomotors_with_three_timers_with_joystick.c,188 :: 		void ton_servo_lower (unsigned int consigne_0)
;Two_servomotors_with_three_timers_with_joystick.c,193 :: 		i = 0;
	CLRF       _i+0
	CLRF       _i+1
;Two_servomotors_with_three_timers_with_joystick.c,195 :: 		do
L_ton_servo_lower12:
;Two_servomotors_with_three_timers_with_joystick.c,197 :: 		Init_Timer2();                         // Restarts 20 mS delay.
	CALL       _Init_Timer2+0
;Two_servomotors_with_three_timers_with_joystick.c,198 :: 		Init_Timer0();                         // Restarts 0,1 mS (100 uS) delay. Resets 100 uS counter cnt0 = 0.
	CALL       _Init_Timer0+0
;Two_servomotors_with_three_timers_with_joystick.c,199 :: 		while(cnt0 < consigne_0)
L_ton_servo_lower15:
	MOVF       FARG_ton_servo_lower_consigne_0+1, 0
	SUBWF      _cnt0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ton_servo_lower80
	MOVF       FARG_ton_servo_lower_consigne_0+0, 0
	SUBWF      _cnt0+0, 0
L__ton_servo_lower80:
	BTFSC      STATUS+0, 0
	GOTO       L_ton_servo_lower16
;Two_servomotors_with_three_timers_with_joystick.c,201 :: 		portd.b0 = 1;                    // Servomotor LOWER ON.
	BSF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,202 :: 		portc.b2 = 1;                    // LED ON.
	BSF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,203 :: 		}
	GOTO       L_ton_servo_lower15
L_ton_servo_lower16:
;Two_servomotors_with_three_timers_with_joystick.c,204 :: 		portd.b0 = 0;
	BCF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,205 :: 		portc.b2 = 0;
	BCF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,206 :: 		i++;
	INCF       _i+0, 1
	BTFSC      STATUS+0, 2
	INCF       _i+1, 1
;Two_servomotors_with_three_timers_with_joystick.c,211 :: 		while(i < 5);
	MOVLW      0
	SUBWF      _i+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ton_servo_lower81
	MOVLW      5
	SUBWF      _i+0, 0
L__ton_servo_lower81:
	BTFSS      STATUS+0, 0
	GOTO       L_ton_servo_lower12
;Two_servomotors_with_three_timers_with_joystick.c,217 :: 		}
L_end_ton_servo_lower:
	RETURN
; end of _ton_servo_lower

_ton_servo_lower_with_turning_time:

;Two_servomotors_with_three_timers_with_joystick.c,219 :: 		void ton_servo_lower_with_turning_time (unsigned int consigne_0, unsigned int turning_time)
;Two_servomotors_with_three_timers_with_joystick.c,224 :: 		i = 0;
	CLRF       _i+0
	CLRF       _i+1
;Two_servomotors_with_three_timers_with_joystick.c,226 :: 		do
L_ton_servo_lower_with_turning_time17:
;Two_servomotors_with_three_timers_with_joystick.c,228 :: 		Init_Timer2();                         // Restarts 20 mS delay.
	CALL       _Init_Timer2+0
;Two_servomotors_with_three_timers_with_joystick.c,229 :: 		Init_Timer0();                         // Restarts 0,1 mS (100 uS) delay. Resets 100 uS counter cnt0 = 0.
	CALL       _Init_Timer0+0
;Two_servomotors_with_three_timers_with_joystick.c,230 :: 		while(cnt0 < consigne_0)
L_ton_servo_lower_with_turning_time20:
	MOVF       FARG_ton_servo_lower_with_turning_time_consigne_0+1, 0
	SUBWF      _cnt0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ton_servo_lower_with_turning_time83
	MOVF       FARG_ton_servo_lower_with_turning_time_consigne_0+0, 0
	SUBWF      _cnt0+0, 0
L__ton_servo_lower_with_turning_time83:
	BTFSC      STATUS+0, 0
	GOTO       L_ton_servo_lower_with_turning_time21
;Two_servomotors_with_three_timers_with_joystick.c,232 :: 		portd.b0 = 1;                    // Servomotor LOWER ON.
	BSF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,233 :: 		portc.b2 = 1;                    // LED ON.
	BSF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,234 :: 		}
	GOTO       L_ton_servo_lower_with_turning_time20
L_ton_servo_lower_with_turning_time21:
;Two_servomotors_with_three_timers_with_joystick.c,235 :: 		portd.b0 = 0;
	BCF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,236 :: 		portc.b2 = 0;
	BCF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,237 :: 		i++;
	INCF       _i+0, 1
	BTFSC      STATUS+0, 2
	INCF       _i+1, 1
;Two_servomotors_with_three_timers_with_joystick.c,239 :: 		while(i < turning_time);                 // Temps de rotation du servomoteur ajustable :
	MOVF       FARG_ton_servo_lower_with_turning_time_turning_time+1, 0
	SUBWF      _i+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ton_servo_lower_with_turning_time84
	MOVF       FARG_ton_servo_lower_with_turning_time_turning_time+0, 0
	SUBWF      _i+0, 0
L__ton_servo_lower_with_turning_time84:
	BTFSS      STATUS+0, 0
	GOTO       L_ton_servo_lower_with_turning_time17
;Two_servomotors_with_three_timers_with_joystick.c,242 :: 		}
L_end_ton_servo_lower_with_turning_time:
	RETURN
; end of _ton_servo_lower_with_turning_time

_ton_servo_upper:

;Two_servomotors_with_three_timers_with_joystick.c,244 :: 		void ton_servo_upper (unsigned int consigne_1)
;Two_servomotors_with_three_timers_with_joystick.c,249 :: 		i = 0;
	CLRF       _i+0
	CLRF       _i+1
;Two_servomotors_with_three_timers_with_joystick.c,251 :: 		do
L_ton_servo_upper22:
;Two_servomotors_with_three_timers_with_joystick.c,253 :: 		Init_Timer2();                         // Restarts 20 mS delay.
	CALL       _Init_Timer2+0
;Two_servomotors_with_three_timers_with_joystick.c,254 :: 		Init_Timer1();                         // Restarts 1 mS.
	CALL       _Init_Timer1+0
;Two_servomotors_with_three_timers_with_joystick.c,255 :: 		while(flag_TMR1 == 1)
L_ton_servo_upper25:
	MOVF       _flag_TMR1+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_ton_servo_upper26
;Two_servomotors_with_three_timers_with_joystick.c,257 :: 		portd.b1 = 1;                    // Servomotor UPPER ON..
	BSF        PORTD+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,258 :: 		portc.b2 = 1;                    // LED ON.
	BSF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,259 :: 		}
	GOTO       L_ton_servo_upper25
L_ton_servo_upper26:
;Two_servomotors_with_three_timers_with_joystick.c,260 :: 		portd.b1 = 0;
	BCF        PORTD+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,261 :: 		portc.b2 = 0;
	BCF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,262 :: 		i++;
	INCF       _i+0, 1
	BTFSC      STATUS+0, 2
	INCF       _i+1, 1
;Two_servomotors_with_three_timers_with_joystick.c,268 :: 		while(i < 50);
	MOVLW      0
	SUBWF      _i+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__ton_servo_upper86
	MOVLW      50
	SUBWF      _i+0, 0
L__ton_servo_upper86:
	BTFSS      STATUS+0, 0
	GOTO       L_ton_servo_upper22
;Two_servomotors_with_three_timers_with_joystick.c,270 :: 		}
L_end_ton_servo_upper:
	RETURN
; end of _ton_servo_upper

_main:

;Two_servomotors_with_three_timers_with_joystick.c,274 :: 		void main()
;Two_servomotors_with_three_timers_with_joystick.c,276 :: 		TRISC = 0;                               // PORT C configur en sortie.
	CLRF       TRISC+0
;Two_servomotors_with_three_timers_with_joystick.c,277 :: 		PORTC = 0;                               // Initialisation du PORT C  0.
	CLRF       PORTC+0
;Two_servomotors_with_three_timers_with_joystick.c,278 :: 		TRISD = 0;                               // PORT D configur en sortie.
	CLRF       TRISD+0
;Two_servomotors_with_three_timers_with_joystick.c,279 :: 		PORTD = 0;                               // Initialisation du PORT D  0.
	CLRF       PORTD+0
;Two_servomotors_with_three_timers_with_joystick.c,281 :: 		ADC_initialization();
	CALL       _ADC_initialization+0
;Two_servomotors_with_three_timers_with_joystick.c,1383 :: 		while(1)
L_main27:
;Two_servomotors_with_three_timers_with_joystick.c,1387 :: 		Init_Timer2();
	CALL       _Init_Timer2+0
;Two_servomotors_with_three_timers_with_joystick.c,1388 :: 		Init_Timer0();
	CALL       _Init_Timer0+0
;Two_servomotors_with_three_timers_with_joystick.c,1390 :: 		p0 = &TMR0;
	MOVLW      TMR0+0
	MOVWF      _p0+0
;Two_servomotors_with_three_timers_with_joystick.c,1392 :: 		joystick_X = (ADC_read(0));             // Reads Y axis value with channel 0 (AN0) on pin #2.
	CLRF       FARG_ADC_read_channel+0
	CALL       _ADC_read+0
	MOVF       R0+0, 0
	MOVWF      _joystick_X+0
	MOVF       R0+1, 0
	MOVWF      _joystick_X+1
;Two_servomotors_with_three_timers_with_joystick.c,1394 :: 		if ((joystick_X <= 500) && (joystick_X > 5))
	MOVLW      128
	XORLW      1
	MOVWF      R2+0
	MOVLW      128
	XORWF      R0+1, 0
	SUBWF      R2+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main88
	MOVF       R0+0, 0
	SUBLW      244
L__main88:
	BTFSS      STATUS+0, 0
	GOTO       L_main31
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      _joystick_X+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main89
	MOVF       _joystick_X+0, 0
	SUBLW      5
L__main89:
	BTFSC      STATUS+0, 0
	GOTO       L_main31
L__main71:
;Two_servomotors_with_three_timers_with_joystick.c,1397 :: 		consigne_0 = 100 + (joystick_X / 10);
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       _joystick_X+0, 0
	MOVWF      R0+0
	MOVF       _joystick_X+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_S+0
	MOVLW      100
	ADDWF      R0+0, 1
	BTFSC      STATUS+0, 0
	INCF       R0+1, 1
	MOVF       R0+0, 0
	MOVWF      _consigne_0+0
	MOVF       R0+1, 0
	MOVWF      _consigne_0+1
;Two_servomotors_with_three_timers_with_joystick.c,1399 :: 		sprintl(*p0, "%3u", consigne_0);
	MOVF       _p0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_sprintl_wh+0
	MOVLW      ?lstr_1_Two_servomotors_with_three_timers_with_joystick+0
	MOVWF      FARG_sprintl_f+0
	MOVLW      hi_addr(?lstr_1_Two_servomotors_with_three_timers_with_joystick+0)
	MOVWF      FARG_sprintl_f+1
	MOVF       R0+0, 0
	MOVWF      FARG_sprintl_wh+3
	MOVF       R0+1, 0
	MOVWF      FARG_sprintl_wh+4
	CALL       _sprintl+0
;Two_servomotors_with_three_timers_with_joystick.c,1401 :: 		Init_Timer2();
	CALL       _Init_Timer2+0
;Two_servomotors_with_three_timers_with_joystick.c,1402 :: 		Init_Timer0();
	CALL       _Init_Timer0+0
;Two_servomotors_with_three_timers_with_joystick.c,1404 :: 		while(cnt0 < (consigne_0 / 10))
L_main32:
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       _consigne_0+0, 0
	MOVWF      R0+0
	MOVF       _consigne_0+1, 0
	MOVWF      R0+1
	CALL       _Div_16X16_U+0
	MOVF       R0+1, 0
	SUBWF      _cnt0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main90
	MOVF       R0+0, 0
	SUBWF      _cnt0+0, 0
L__main90:
	BTFSC      STATUS+0, 0
	GOTO       L_main33
;Two_servomotors_with_three_timers_with_joystick.c,1406 :: 		portd.b1 = 0;
	BCF        PORTD+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,1407 :: 		portd.b0 = 1;                      // Servomotor LOWER ON.
	BSF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,1408 :: 		portc.b2 = 1;                      // LED ON.
	BSF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,1409 :: 		}
	GOTO       L_main32
L_main33:
;Two_servomotors_with_three_timers_with_joystick.c,1411 :: 		portd.b0 = 0;
	BCF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,1412 :: 		portc.b2 = 0;
	BCF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,1413 :: 		}
L_main31:
;Two_servomotors_with_three_timers_with_joystick.c,1415 :: 		if ((joystick_X >= 512) && (joystick_X < 1012))
	MOVLW      128
	XORWF      _joystick_X+1, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      2
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main91
	MOVLW      0
	SUBWF      _joystick_X+0, 0
L__main91:
	BTFSS      STATUS+0, 0
	GOTO       L_main36
	MOVLW      128
	XORWF      _joystick_X+1, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      3
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main92
	MOVLW      244
	SUBWF      _joystick_X+0, 0
L__main92:
	BTFSC      STATUS+0, 0
	GOTO       L_main36
L__main70:
;Two_servomotors_with_three_timers_with_joystick.c,1418 :: 		consigne_0 = 150 + (joystick_X - 512) / 10;
	MOVLW      0
	SUBWF      _joystick_X+0, 0
	MOVWF      R0+0
	MOVLW      2
	BTFSS      STATUS+0, 0
	ADDLW      1
	SUBWF      _joystick_X+1, 0
	MOVWF      R0+1
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	CALL       _Div_16x16_S+0
	MOVLW      150
	ADDWF      R0+0, 1
	BTFSC      STATUS+0, 0
	INCF       R0+1, 1
	MOVF       R0+0, 0
	MOVWF      _consigne_0+0
	MOVF       R0+1, 0
	MOVWF      _consigne_0+1
;Two_servomotors_with_three_timers_with_joystick.c,1420 :: 		sprintl(*p0, "%3u", consigne_0);
	MOVF       _p0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_sprintl_wh+0
	MOVLW      ?lstr_2_Two_servomotors_with_three_timers_with_joystick+0
	MOVWF      FARG_sprintl_f+0
	MOVLW      hi_addr(?lstr_2_Two_servomotors_with_three_timers_with_joystick+0)
	MOVWF      FARG_sprintl_f+1
	MOVF       R0+0, 0
	MOVWF      FARG_sprintl_wh+3
	MOVF       R0+1, 0
	MOVWF      FARG_sprintl_wh+4
	CALL       _sprintl+0
;Two_servomotors_with_three_timers_with_joystick.c,1422 :: 		Init_Timer2();
	CALL       _Init_Timer2+0
;Two_servomotors_with_three_timers_with_joystick.c,1423 :: 		Init_Timer0();
	CALL       _Init_Timer0+0
;Two_servomotors_with_three_timers_with_joystick.c,1425 :: 		while(cnt0 < (consigne_0 / 10))
L_main37:
	MOVLW      10
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVF       _consigne_0+0, 0
	MOVWF      R0+0
	MOVF       _consigne_0+1, 0
	MOVWF      R0+1
	CALL       _Div_16X16_U+0
	MOVF       R0+1, 0
	SUBWF      _cnt0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main93
	MOVF       R0+0, 0
	SUBWF      _cnt0+0, 0
L__main93:
	BTFSC      STATUS+0, 0
	GOTO       L_main38
;Two_servomotors_with_three_timers_with_joystick.c,1427 :: 		portd.b1 = 0;
	BCF        PORTD+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,1428 :: 		portd.b0 = 1;                      // Servomotor LOWER ON.
	BSF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,1429 :: 		portc.b2 = 1;                      // LED ON.
	BSF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,1430 :: 		}
	GOTO       L_main37
L_main38:
;Two_servomotors_with_three_timers_with_joystick.c,1432 :: 		portd.b0 = 0;
	BCF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,1433 :: 		portc.b2 = 0;
	BCF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,1434 :: 		}
L_main36:
;Two_servomotors_with_three_timers_with_joystick.c,1436 :: 		if ((joystick_X > 500) && (joystick_X < 512))
	MOVLW      128
	XORLW      1
	MOVWF      R0+0
	MOVLW      128
	XORWF      _joystick_X+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main94
	MOVF       _joystick_X+0, 0
	SUBLW      244
L__main94:
	BTFSC      STATUS+0, 0
	GOTO       L_main41
	MOVLW      128
	XORWF      _joystick_X+1, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      2
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main95
	MOVLW      0
	SUBWF      _joystick_X+0, 0
L__main95:
	BTFSC      STATUS+0, 0
	GOTO       L_main41
L__main69:
;Two_servomotors_with_three_timers_with_joystick.c,1438 :: 		portd.b1 = 0;
	BCF        PORTD+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,1439 :: 		portd.b0 = 0;
	BCF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,1440 :: 		portc.b2 = 0;
	BCF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,1441 :: 		}
L_main41:
;Two_servomotors_with_three_timers_with_joystick.c,1445 :: 		Init_Timer2();
	CALL       _Init_Timer2+0
;Two_servomotors_with_three_timers_with_joystick.c,1446 :: 		Init_Timer1();
	CALL       _Init_Timer1+0
;Two_servomotors_with_three_timers_with_joystick.c,1448 :: 		p1 = &TMR1L;
	MOVLW      TMR1L+0
	MOVWF      _p1+0
;Two_servomotors_with_three_timers_with_joystick.c,1450 :: 		joystick_Y = (ADC_read(1));             // Reads Y axis value with channel 1 (AN1) on pin #3.
	MOVLW      1
	MOVWF      FARG_ADC_read_channel+0
	CALL       _ADC_read+0
	MOVF       R0+0, 0
	MOVWF      _joystick_Y+0
	MOVF       R0+1, 0
	MOVWF      _joystick_Y+1
;Two_servomotors_with_three_timers_with_joystick.c,1453 :: 		if ((joystick_Y <= 490) && (joystick_Y > 250))
	MOVLW      128
	XORLW      1
	MOVWF      R2+0
	MOVLW      128
	XORWF      R0+1, 0
	SUBWF      R2+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main96
	MOVF       R0+0, 0
	SUBLW      234
L__main96:
	BTFSS      STATUS+0, 0
	GOTO       L_main44
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      _joystick_Y+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main97
	MOVF       _joystick_Y+0, 0
	SUBLW      250
L__main97:
	BTFSC      STATUS+0, 0
	GOTO       L_main44
L__main68:
;Two_servomotors_with_three_timers_with_joystick.c,1455 :: 		portd.b0 = 0;
	BCF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,1456 :: 		consigne_1 = 65535 - 1500;          // consigne_1 = 65535 - 1500 => 64035  65535 = 1500 x 1 uS = 1,5 mS = Ton.
	MOVLW      35
	MOVWF      _consigne_1+0
	MOVLW      250
	MOVWF      _consigne_1+1
;Two_servomotors_with_three_timers_with_joystick.c,1458 :: 		sprintl(*p1, "%5u", consigne_1);    // In Library Manager check box Sprintl and check box C_Type are selected automatically.
	MOVF       _p1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_sprintl_wh+0
	MOVLW      ?lstr_3_Two_servomotors_with_three_timers_with_joystick+0
	MOVWF      FARG_sprintl_f+0
	MOVLW      hi_addr(?lstr_3_Two_servomotors_with_three_timers_with_joystick+0)
	MOVWF      FARG_sprintl_f+1
	MOVLW      35
	MOVWF      FARG_sprintl_wh+3
	MOVLW      250
	MOVWF      FARG_sprintl_wh+4
	CALL       _sprintl+0
;Two_servomotors_with_three_timers_with_joystick.c,1459 :: 		Delay_ms(1000);                     // Dlais AJUSTABLE pour dfinir l'angle de rotation.
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L_main45:
	DECFSZ     R13+0, 1
	GOTO       L_main45
	DECFSZ     R12+0, 1
	GOTO       L_main45
	DECFSZ     R11+0, 1
	GOTO       L_main45
	NOP
	NOP
;Two_servomotors_with_three_timers_with_joystick.c,1460 :: 		}
L_main44:
;Two_servomotors_with_three_timers_with_joystick.c,1462 :: 		if ((joystick_Y <= 250) && (joystick_Y > 0))
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      _joystick_Y+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main98
	MOVF       _joystick_Y+0, 0
	SUBLW      250
L__main98:
	BTFSS      STATUS+0, 0
	GOTO       L_main48
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      _joystick_Y+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main99
	MOVF       _joystick_Y+0, 0
	SUBLW      0
L__main99:
	BTFSC      STATUS+0, 0
	GOTO       L_main48
L__main67:
;Two_servomotors_with_three_timers_with_joystick.c,1464 :: 		portd.b0 = 0;
	BCF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,1465 :: 		consigne_1 = 65535 - 1750;          // consigne_1 = 65535 - 1750 => 63785  65535 = 1750 x 1 uS = 1,75 mS = Ton.
	MOVLW      41
	MOVWF      _consigne_1+0
	MOVLW      249
	MOVWF      _consigne_1+1
;Two_servomotors_with_three_timers_with_joystick.c,1467 :: 		sprintl(*p1, "%5u", consigne_1);    // In Library Manager check box Sprintl and check box C_Type are selected automatically.
	MOVF       _p1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_sprintl_wh+0
	MOVLW      ?lstr_4_Two_servomotors_with_three_timers_with_joystick+0
	MOVWF      FARG_sprintl_f+0
	MOVLW      hi_addr(?lstr_4_Two_servomotors_with_three_timers_with_joystick+0)
	MOVWF      FARG_sprintl_f+1
	MOVLW      41
	MOVWF      FARG_sprintl_wh+3
	MOVLW      249
	MOVWF      FARG_sprintl_wh+4
	CALL       _sprintl+0
;Two_servomotors_with_three_timers_with_joystick.c,1468 :: 		Delay_ms(1000);                     // Dlais AJUSTABLE pour dfinir l'angle de rotation.
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L_main49:
	DECFSZ     R13+0, 1
	GOTO       L_main49
	DECFSZ     R12+0, 1
	GOTO       L_main49
	DECFSZ     R11+0, 1
	GOTO       L_main49
	NOP
	NOP
;Two_servomotors_with_three_timers_with_joystick.c,1469 :: 		}
L_main48:
;Two_servomotors_with_three_timers_with_joystick.c,1472 :: 		if ((joystick_Y >= 534) && (joystick_Y < 774))
	MOVLW      128
	XORWF      _joystick_Y+1, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      2
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main100
	MOVLW      22
	SUBWF      _joystick_Y+0, 0
L__main100:
	BTFSS      STATUS+0, 0
	GOTO       L_main52
	MOVLW      128
	XORWF      _joystick_Y+1, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      3
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main101
	MOVLW      6
	SUBWF      _joystick_Y+0, 0
L__main101:
	BTFSC      STATUS+0, 0
	GOTO       L_main52
L__main66:
;Two_servomotors_with_three_timers_with_joystick.c,1474 :: 		portd.b0 = 0;
	BCF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,1475 :: 		consigne_1 = 65535 - 1400;          // consigne_1 = 65535 - 1400 => 64135  65535 = 1400 x 1 uS = 1,4 mS = Ton.
	MOVLW      135
	MOVWF      _consigne_1+0
	MOVLW      250
	MOVWF      _consigne_1+1
;Two_servomotors_with_three_timers_with_joystick.c,1477 :: 		sprintl(*p1, "%5u", consigne_1);    // In Library Manager check box Sprintl and check box C_Type are selected automatically.
	MOVF       _p1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_sprintl_wh+0
	MOVLW      ?lstr_5_Two_servomotors_with_three_timers_with_joystick+0
	MOVWF      FARG_sprintl_f+0
	MOVLW      hi_addr(?lstr_5_Two_servomotors_with_three_timers_with_joystick+0)
	MOVWF      FARG_sprintl_f+1
	MOVLW      135
	MOVWF      FARG_sprintl_wh+3
	MOVLW      250
	MOVWF      FARG_sprintl_wh+4
	CALL       _sprintl+0
;Two_servomotors_with_three_timers_with_joystick.c,1478 :: 		Delay_ms(1000);                     // Dlais AJUSTABLE pour dfinir l'angle de rotation.
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L_main53:
	DECFSZ     R13+0, 1
	GOTO       L_main53
	DECFSZ     R12+0, 1
	GOTO       L_main53
	DECFSZ     R11+0, 1
	GOTO       L_main53
	NOP
	NOP
;Two_servomotors_with_three_timers_with_joystick.c,1479 :: 		}
L_main52:
;Two_servomotors_with_three_timers_with_joystick.c,1481 :: 		if ((joystick_Y >= 774) && (joystick_Y < 1024))
	MOVLW      128
	XORWF      _joystick_Y+1, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      3
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main102
	MOVLW      6
	SUBWF      _joystick_Y+0, 0
L__main102:
	BTFSS      STATUS+0, 0
	GOTO       L_main56
	MOVLW      128
	XORWF      _joystick_Y+1, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      4
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main103
	MOVLW      0
	SUBWF      _joystick_Y+0, 0
L__main103:
	BTFSC      STATUS+0, 0
	GOTO       L_main56
L__main65:
;Two_servomotors_with_three_timers_with_joystick.c,1483 :: 		portd.b0 = 0;
	BCF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,1484 :: 		consigne_1 = 65535 - 1250;          // consigne_1 = 65535 - 1250 => 64285  65535 = 1250 x 1 uS = 1,25 mS = Ton.
	MOVLW      29
	MOVWF      _consigne_1+0
	MOVLW      251
	MOVWF      _consigne_1+1
;Two_servomotors_with_three_timers_with_joystick.c,1486 :: 		sprintl(*p1, "%5u", consigne_1);    // In Library Manager check box Sprintl and check box C_Type are selected automatically.
	MOVF       _p1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_sprintl_wh+0
	MOVLW      ?lstr_6_Two_servomotors_with_three_timers_with_joystick+0
	MOVWF      FARG_sprintl_f+0
	MOVLW      hi_addr(?lstr_6_Two_servomotors_with_three_timers_with_joystick+0)
	MOVWF      FARG_sprintl_f+1
	MOVLW      29
	MOVWF      FARG_sprintl_wh+3
	MOVLW      251
	MOVWF      FARG_sprintl_wh+4
	CALL       _sprintl+0
;Two_servomotors_with_three_timers_with_joystick.c,1487 :: 		Delay_ms(1000);                     // Dlais AJUSTABLE pour dfinir l'angle de rotation.
	MOVLW      6
	MOVWF      R11+0
	MOVLW      19
	MOVWF      R12+0
	MOVLW      173
	MOVWF      R13+0
L_main57:
	DECFSZ     R13+0, 1
	GOTO       L_main57
	DECFSZ     R12+0, 1
	GOTO       L_main57
	DECFSZ     R11+0, 1
	GOTO       L_main57
	NOP
	NOP
;Two_servomotors_with_three_timers_with_joystick.c,1488 :: 		}
L_main56:
;Two_servomotors_with_three_timers_with_joystick.c,1491 :: 		if ((joystick_Y > 490) && (joystick_Y < 534))
	MOVLW      128
	XORLW      1
	MOVWF      R0+0
	MOVLW      128
	XORWF      _joystick_Y+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main104
	MOVF       _joystick_Y+0, 0
	SUBLW      234
L__main104:
	BTFSC      STATUS+0, 0
	GOTO       L_main60
	MOVLW      128
	XORWF      _joystick_Y+1, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      2
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main105
	MOVLW      22
	SUBWF      _joystick_Y+0, 0
L__main105:
	BTFSC      STATUS+0, 0
	GOTO       L_main60
L__main64:
;Two_servomotors_with_three_timers_with_joystick.c,1494 :: 		portd.b0 = 0;
	BCF        PORTD+0, 0
;Two_servomotors_with_three_timers_with_joystick.c,1495 :: 		portd.b1 = 0;
	BCF        PORTD+0, 1
;Two_servomotors_with_three_timers_with_joystick.c,1496 :: 		portc.b2 = 0;
	BCF        PORTC+0, 2
;Two_servomotors_with_three_timers_with_joystick.c,1497 :: 		}
L_main60:
;Two_servomotors_with_three_timers_with_joystick.c,1498 :: 		}
	GOTO       L_main27
;Two_servomotors_with_three_timers_with_joystick.c,1500 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
